/* quote.c   by Michael Thorpe   2005-07-25 */

#include <string.h>
#include "lisp.h"

static void drop_quote(obj *o) {
	decref(o->value.o);
}

static obj *quote_evaluate(scope *s,obj *in) {
	obj *out;

	decscoperef(s);
	out=incref(in->value.o);
	decref(in);
	return(out);
}

static obj *quote_tostring(obj *in) {
	obj *out,*s;

	s=(in->value.o->type->tostring)(incref(in->value.o));
	decref(in);
	if(s) {
		out=real_new_string(0,s->value.s.len+1);
		if(out) {
			out->value.s.data[0]='\'';
			memcpy(out->value.s.data+1,s->value.s.data,s->value.s.len);
		}
		decref(s);
		return(out);
	}
	return(s);
}

obj *quoteobj(obj *o) {
	obj *q;

	q=newobj(&quote_objtype);
	if(!q) {
		decref(o);
		return(0);
	}
	q->value.o=o;
	return(q);
}

int quote_init() {
	if(store_builtin_ns1("quote",quoteobj))
		return(1);
	return(0);
}

objtype quote_objtype={
	name: "quote",
	tostring: quote_tostring,
	dropobj: drop_quote,
	evaluate: quote_evaluate
};

